using System;
using System.Collections.Generic;
using System.Linq;
using Android.App;
using Android.Content;
using Android.Hardware.Usb;
using Android.OS;
using Android.Provider;
using Android.Widget;
using Master.AndroidCode.Testing;
using Master.Core;

namespace Master.AndroidCode.API
{

    [Service]
    [IntentFilter(new String[] { "com.aalbergAudio.GuitarController" })]
    public class GuitarControllerService : Service
    {
        private const bool Debug = true;
        private Api _api;
        private IController _controller;
        public string SaveName { get; set; }
        public const string UpdatedAction = "ConnectedDevicesUpdated";
        IBinder _binder;


        public bool CheckForUpdates()
        {
            return _api.CheckForUpdates();
        }

        public List<string> GetConnectedDeviceNames()
        {
            return _api.GetConnectedDeviceNames();
        }
        public List<string> GetConnectedDeviceIds()
        {
            return _api.GetConnectedDeviceIds();
        }

        public bool SaveProfile(string saveName, List<IPedal> pedals)
        {
            return _api.SaveProfile(saveName, pedals);
        }
        public Dictionary<String, List<IPedal>> GetSavedProfiles()
        {
            return _api.GetSavedProfiles();
        }

        public List<IPedal> GetSavedProfile(String name)
        {
            return _api.GetSavedProfile(name);
        }

         public List<IPedal> GetConnectedDevices()
        {
            return _api.GetConnectedDevices();
        }
        public IPedal GetConnectedDevice(string id)
        {
            return _api.GetConnectedDevice(id);
        } 

    public override IBinder OnBind (Intent intent)
    {

        var a = (UsbManager) GetSystemService(Context.UsbService);
        Console.WriteLine(a.DeviceList.Count);
        Console.WriteLine(a.GetAccessoryList());
                _binder = new GuitarControllerServiceBinder (this);
                _controller = ControllerFactory.CreateController(ConnectionTypes.Usb, this);
                if (_controller.IsConnected()) return _binder;
                Console.WriteLine("_Controller not connected?!?");
                if (!Debug)
                {
                    Toast.MakeText(this, "No Ecco attached. Please plug one in", ToastLength.Long).Show();
                }
                else
                {
                    _controller = new UsbController(new MockUsbManager());
                }
                _api = new Api(_controller);
                return _binder;
        }

    public class GuitarControllerServiceBinder : Binder
        {
        readonly GuitarControllerService _service;

                public GuitarControllerServiceBinder (GuitarControllerService service)
                {
                        _service = service;
                }

                public GuitarControllerService GetGuitarControllerService ()
                {
                        return _service;
                }
        }

    }
}