﻿using System;
using System.Collections.Generic;
using System.Linq;
using Master.Core;

namespace Master.AndroidCode.Testing
{
	public class ControllerMock : AbstractController
	{
		public ControllerMock ()
		{
            _pedals.Add(new Pedal("Device1,123123,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;", this));
            _pedals.Add(new Pedal("Device2,122123,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;", this));
            _pedals.Add(new Pedal("Device3,112323,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;", this));
		}
	    public override string SaveName { get; set; }
        private readonly List<IPedal> _pedals = new List<IPedal>(); 

	    protected override String GetConnectedDeviceString()
        {  
            return "Device1,123123,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;Device2,122123,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;Device3,112323,Version 1.0, Option1:1:0:100,Option2:1:0:100,Option3:1:0:100;";
        }

	    public override void UpdateOption(string id, string option, int value)
	    {
	        foreach (var pedal in _pedals.Where(pedal => pedal.Id == id))
	        {
	            pedal.Options[option].Value = value;
                return;
	        }
            
	    }

	    public override bool IsConnected()
	    {
	        return false;
	    }

	    public override void SendFirmwareToDevice(string readToEnd)
	    {
	    }
	}
}

