﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Master.Core
{
    class Api
    {
        private readonly IController _controller;
        public string SaveName { get; set; }
        public const string UpdatedAction = "ConnectedDevicesUpdated";

        public Api(IController controller)
        {
            _controller = controller;
        }

        public bool CheckForUpdates()
        {
            return _controller.CheckForUpdates();
        }

        public List<string> GetConnectedDeviceNames()
        {
            return _controller.GetConnectedDeviceNames();
        }
        public List<string> GetConnectedDeviceIds()
        {
            return _controller.GetConnectedDeviceIds();
        }

        public bool SaveProfile(string saveName, List<IPedal> pedals)
        {
            return StorageManager.Save(pedals, saveName);
        }
        public Dictionary<String, List<IPedal>> GetSavedProfiles()
        {
            return StorageManager.Load();
        }

        public List<IPedal> GetSavedProfile(String name)
        {
            var profiles = StorageManager.Load();
            return profiles.Where(profile => profile.Key.Equals(name)).Select(profile => profile.Value).FirstOrDefault();
        }


        public List<IPedal> GetConnectedDevices()
        {
            return _controller.GetConnectedDevices();
        }
        public IPedal GetConnectedDevice(string id)
        {
            return _controller.GetDeviceById(id);
        }
    }
}
