using Android.Content;
using Android.Hardware.Usb;
using Master.AndroidCode;
using Master.AndroidCode.Testing;

namespace Master.Core
{
    public enum ConnectionTypes
    {
        Usb, Mock
    }

    class ControllerFactory 
    {
        static public IController CreateController(ConnectionTypes type, Context context)
        {
            
            switch (type)
            {
                case ConnectionTypes.Mock: return new ControllerMock();
                case ConnectionTypes.Usb:
                    return
                        new UsbController(
                            new TestableUsbManager(
                                (UsbManager) context.GetSystemService(Context.UsbService)
                                )
                            );
                default: return new ControllerMock();
            }
        }
    }
}